=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Release -DXRT_NPU=1 -DXRT_UPSTREAM_DEBIAN=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --sourcedir=src -- $(CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install
	# man pages
	mkdir -p debian/libxrt-utils/usr/share/man/man1
	# doesn't work for xrt-runner xrt-smi xrt-tracer
	for bin in xclbinutil xrt-replay; do \
	  LD_LIBRARY_PATH=debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE) help2man debian/tmp/usr/bin/$$bin > debian/libxrt-utils/usr/share/man/man1/$$bin.1; \
	done
	# bash completion
	mkdir -p debian/libxrt-utils/usr/share/bash-completion/completions
	install -m 644 debian/tmp/usr/share/completions/xbutil-bash-completion debian/libxrt-utils/usr/share/bash-completion/completions/xbutil

override_dh_auto_test:
	-dh_auto_test
